## openvdb 3.1.0

=== Makefile ===
# Copyright (c) 2012-2015 DreamWorks Animation LLC
#
# All rights reserved. This software is distributed under the
# Mozilla Public License 2.0 ( http://www.mozilla.org/MPL/2.0/ )
#
# Redistributions of source code must retain the above copyright
# and license notice and the following restrictions and disclaimer.
#
# *     Neither the name of DreamWorks Animation nor the names of
# its contributors may be used to endorse or promote products derived
# from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# IN NO EVENT SHALL THE COPYRIGHT HOLDERS' AND CONTRIBUTORS' AGGREGATE
# LIABILITY FOR ALL CLAIMS REGARDLESS OF THEIR BASIS EXCEED US$250.00.
#
# Makefile for the OpenVDB library

# See INSTALL for a list of requirements.
#
# Targets:
#   lib                 the OpenVDB library
#
#   doc                 HTML documentation (doc/html/index.html)
#   pdfdoc              PDF documentation (doc/latex/refman.pdf;
#                       requires LaTeX and ghostscript)
#   python              OpenVDB Python module
#   pytest              unit tests for the Python module
#   pydoc               HTML documentation for the Python module
#                       (doc/html/python/index.html)
#   vdb_print           command-line tool to inspect OpenVDB files
#   vdb_render          command-line tool to ray-trace OpenVDB files
#   vdb_view            command-line tool to view OpenVDB files
#   vdb_test            unit tests for the OpenVDB library
#
#   all                 [default target] all of the above
#   install             install all of the above except vdb_test
#                       into subdirectories of DESTDIR
#   depend              recompute source file header dependencies
#   clean               delete generated files from the local directory
#   test                run tests
#
# Options:
#   abi=2               build for compatibility with the OpenVDB 2.x Grid ABI
#                       (some OpenVDB 3.x features will be disabled)
#   shared=no           link executables against static OpenVDB libraries
#                       (default: link against shared libraries)
#   debug=yes           build with debugging symbols and without optimization
#   verbose=yes         run commands (e.g., doxygen) in verbose mode


#
# The following variables must be defined, either here or on the command line
# (e.g., "make install DESTDIR=/usr/local"):
#
# Note that if you plan to build the Houdini OpenVDB tools (distributed
# separately), you must build the OpenVDB library and the Houdini tools
# against compatible versions of the Boost, OpenEXR and TBB libraries.
# Fortunately, all three are included in the Houdini HDK, so the relevant
# variables below point by default to the HDK library and header directories:
# $(HDSO) and $(HT)/include, respectively.  (Source the houdini_setup script
# to set those two environment variables.)
#
# To build the OpenVDB Python module, you will need local distributions of
# Python, Boost.Python, and optionally NumPy.  As of Houdini 12.5, the HDK
# includes versions 2.5 and 2.6 of Python as well as the Boost.Python headers.
# Unfortunately, it does not include the libboost_python library, nor does it
# include NumPy, so both Boost.Python and NumPy have to be built separately.
# Point the variables $(BOOST_PYTHON_LIB_DIR), $(BOOST_PYTHON_LIB) and
# $(NUMPY_INCL_DIR) below to your local distributions of those libraries.
#

# The directory into which to install libraries, executables and header files
DESTDIR := /tmp/OpenVDB

# The parent directory of the boost/ header directory
BOOST_INCL_DIR := $(HT)/include
# The directory containing libboost_iostreams, libboost_system, etc.
BOOST_LIB_DIR := $(HDSO)
BOOST_LIB := -lboost_iostreams -lboost_system
BOOST_THREAD_LIB := -lboost_thread

# The parent directory of the OpenEXR/ header directory
EXR_INCL_DIR := $(HT)/include
# The directory containing IlmImf
EXR_LIB_DIR := $(HDSO)
EXR_LIB := -lIlmImf

# The parent directory of the OpenEXR/ header directory (which contains half.h)
ILMBASE_INCL_DIR := $(EXR_INCL_DIR)
# The directory containing libIlmThread, libIlmThread, libHalf etc.
ILMBASE_LIB_DIR := $(EXR_LIB_DIR)
ILMBASE_LIB := -lIlmThread -lIex -lImath
HALF_LIB := -lHalf

# The parent directory of the tbb/ header directory
TBB_INCL_DIR := $(HT)/include
# The directory containing libtbb
TBB_LIB_DIR := $(HDSO)
TBB_LIB := -ltbb

# The parent directory of the blosc.h header
# (leave blank if Blosc is unavailable)
BLOSC_INCL_DIR := $(HT)/include
# The directory containing libblosc
BLOSC_LIB_DIR := $(HDSO)
BLOSC_LIB := -lblosc

# A scalable, concurrent malloc replacement library
# such as jemalloc (included in the Houdini HDK) or TBB malloc
# (leave blank if unavailable)
CONCURRENT_MALLOC_LIB := -ljemalloc
#CONCURRENT_MALLOC_LIB := -ltbbmalloc_proxy -ltbbmalloc
# The directory containing the malloc replacement library
CONCURRENT_MALLOC_LIB_DIR := $(HDSO)

# The parent directory of the cppunit/ header directory
# (leave blank if CppUnit is unavailable)
CPPUNIT_INCL_DIR := /rel/map/generic-2013.22/sys_include
# The directory containing libcppunit
CPPUNIT_LIB_DIR := /rel/depot/third_party_build/cppunit/1.10.2-7/opt-ws5-x86_64-gccWS5_64/lib
CPPUNIT_LIB := -lcppunit

# The parent directory of the log4cplus/ header directory
# (leave blank if log4cplus is unavailable)
LOG4CPLUS_INCL_DIR := /rel/folio/log4cplus/log4cplus-1.0.3-latest/sys_include
# The directory containing liblog4cplus
LOG4CPLUS_LIB_DIR := /rel/folio/log4cplus/log4cplus-1.0.3-latest/library
LOG4CPLUS_LIB := -llog4cplus

# The directory containing glfw.h
# (leave blank if GLFW is unavailable)
GLFW_INCL_DIR := /rel/third_party/glfw/glfw-3.0.1/include
# The directory containing libglfw
GLFW_LIB_DIR := /rel/third_party/glfw/glfw-3.0.1/lib
GLFW_LIB := -lglfw
# The major version number of the GLFW library
# (header filenames changed between GLFW 2 and 3, so this must be specified explicitly)
GLFW_MAJOR_VERSION := 3

# The version of Python for which to build the OpenVDB module
# (leave blank if Python is unavailable)
PYTHON_VERSION := 2.6
# The directory containing Python.h
PYTHON_INCL_DIR := $(HFS)/python/include/python$(PYTHON_VERSION)
# The directory containing pyconfig.h
PYCONFIG_INCL_DIR := $(PYTHON_INCL_DIR)
# The directory containing libpython
PYTHON_LIB_DIR := $(HFS)/python/lib
PYTHON_LIB := -lpython$(PYTHON_VERSION)
# The directory containing libboost_python
BOOST_PYTHON_LIB_DIR := /rel/depot/third_party_build/boost/rhel6-1.46.1-0/lib
BOOST_PYTHON_LIB := -lboost_python-gcc41-mt-python26-1_46_1
# The directory containing arrayobject.h
# (leave blank if NumPy is unavailable)
NUMPY_INCL_DIR := /rel/map/generic-2013.22/include
# The Epydoc executable
# (leave blank if Epydoc is unavailable)
EPYDOC := epydoc
# Set PYTHON_WRAP_ALL_GRID_TYPES to "yes" to specify that the Python module
# should expose (almost) all of the grid types defined in openvdb.h
# Otherwise, only FloatGrid, BoolGrid and Vec3SGrid will be exposed
# (see, e.g., exportIntGrid() in python/pyIntGrid.cc).
# Compiling the Python module with PYTHON_WRAP_ALL_GRID_TYPES set to "yes"
# can be very memory-intensive.
PYTHON_WRAP_ALL_GRID_TYPES := no

# The Doxygen executable
# (leave blank if Doxygen is unavailable)
DOXYGEN := doxygen


#
# Ideally, users shouldn't need to change anything below this line.
#

SHELL = /bin/bash

# Turn off implicit rules for speed.
.SUFFIXES:

ifneq (,$(INSTALL_DIR))
    $(warning Warning: $$(INSTALL_DIR) is no longer used; set $$(DESTDIR) instead.)
endif

# Determine the platform.
ifeq ("$(OS)","Windows_NT")
    WINDOWS_NT := 1
else
    UNAME_S := $(shell uname -s)
    ifeq ("$(UNAME_S)","Linux")
        LINUX := 1
    else
        ifeq ("$(UNAME_S)","Darwin")
            MBSD := 1
        endif
    endif
endif

ifeq (yes,$(strip $(debug)))
    OPTIMIZE := -g
else
    OPTIMIZE := -O3 -DNDEBUG
endif

ifeq (yes,$(strip $(verbose)))
    QUIET :=
    QUIET_TEST := -v
else
    QUIET := > /dev/null
    QUIET_TEST := $(QUIET)
endif

has_blosc := no
ifneq (,$(and $(BLOSC_LIB_DIR),$(BLOSC_INCL_DIR),$(BLOSC_LIB)))
    has_blosc := yes
endif

has_glfw := no
ifneq (,$(and $(GLFW_LIB_DIR),$(GLFW_INCL_DIR),$(GLFW_LIB)))
    has_glfw := yes
endif

has_log4cplus := no
ifneq (,$(and $(LOG4CPLUS_LIB_DIR),$(LOG4CPLUS_INCL_DIR),$(LOG4CPLUS_LIB)))
    has_log4cplus := yes
endif

has_python := no
ifneq (,$(and $(PYTHON_VERSION),$(PYTHON_LIB_DIR),$(PYTHON_INCL_DIR), \
    $(PYCONFIG_INCL_DIR),$(PYTHON_LIB),$(BOOST_PYTHON_LIB_DIR),$(BOOST_PYTHON_LIB)))
    has_python := yes
endif

INCLDIRS := -I . -I .. -isystem $(BOOST_INCL_DIR) -isystem $(ILMBASE_INCL_DIR) -isystem $(TBB_INCL_DIR)
ifeq (yes,$(has_blosc))
    INCLDIRS += -isystem $(BLOSC_INCL_DIR)
endif
ifeq (yes,$(has_log4cplus))
    INCLDIRS += -isystem $(LOG4CPLUS_INCL_DIR)
endif

CXXFLAGS += -pthread $(OPTIMIZE) $(INCLDIRS)
ifeq (yes,$(has_blosc))
    CXXFLAGS += -DOPENVDB_USE_BLOSC
endif
ifeq (yes,$(has_log4cplus))
    CXXFLAGS += -DOPENVDB_USE_LOG4CPLUS
endif
ifeq (2,$(strip $(abi)))
    CXXFLAGS += -DOPENVDB_2_ABI_COMPATIBLE
endif
ifneq (2,$(strip $(GLFW_MAJOR_VERSION)))
    CXXFLAGS += -DOPENVDB_USE_GLFW_3
endif

LIBS := \
    -ldl -lm -lz \
    -L$(ILMBASE_LIB_DIR) $(HALF_LIB) \
    -L$(TBB_LIB_DIR) $(TBB_LIB) \
    -L$(BOOST_LIB_DIR) $(BOOST_LIB) \
#
LIBS_RPATH := \
    -ldl -lm -lz \
    -Wl,-rpath,$(ILMBASE_LIB_DIR) -L$(ILMBASE_LIB_DIR) $(HALF_LIB) \
    -Wl,-rpath,$(TBB_LIB_DIR) -L$(TBB_LIB_DIR) $(TBB_LIB) \
    -Wl,-rpath,$(BOOST_LIB_DIR) -L$(BOOST_LIB_DIR) $(BOOST_LIB) \
#
ifeq (yes,$(has_blosc))
    LIBS += -L$(BLOSC_LIB_DIR) $(BLOSC_LIB)
    LIBS_RPATH += -Wl,-rpath,$(BLOSC_LIB_DIR) -L$(BLOSC_LIB_DIR) $(BLOSC_LIB)
endif
ifeq (yes,$(has_log4cplus))
    LIBS += -L$(LOG4CPLUS_LIB_DIR) $(LOG4CPLUS_LIB)
    LIBS_RPATH += -Wl,-rpath,$(LOG4CPLUS_LIB_DIR) -L$(LOG4CPLUS_LIB_DIR) $(LOG4CPLUS_LIB)
endif
ifneq (,$(strip $(CONCURRENT_MALLOC_LIB)))
ifneq (,$(strip $(CONCURRENT_MALLOC_LIB_DIR)))
    LIBS_RPATH += -Wl,-rpath,$(CONCURRENT_MALLOC_LIB_DIR) -L$(CONCURRENT_MALLOC_LIB_DIR)
endif
endif
ifdef LINUX
    LIBS += -lrt
    LIBS_RPATH += -lrt
endif

INCLUDE_NAMES := \
    Exceptions.h \
    Grid.h \
    io/Archive.h \
    io/Compression.h \
    io/File.h \
    io/GridDescriptor.h \
    io/io.h \
    io/Queue.h \
    io/Stream.h \
    io/TempFile.h \
    math/BBox.h \
    math/ConjGradient.h \
    math/Coord.h \
    math/DDA.h \
    math/FiniteDifference.h \
    math/LegacyFrustum.h \
    math/Maps.h \
    math/Mat.h \
    math/Mat3.h \
    math/Mat4.h \
    math/Math.h \
    math/Operators.h \
    math/Proximity.h \
    math/QuantizedUnitVec.h \
    math/Quat.h \
    math/Ray.h \
    math/Stats.h \
    math/Stencils.h \
    math/Transform.h\
    math/Tuple.h\
    math/Vec2.h \
    math/Vec3.h \
    math/Vec4.h \
    Metadata.h \
    metadata/Metadata.h \
    metadata/MetaMap.h \
    metadata/StringMetadata.h \
    openvdb.h \
    Platform.h \
    PlatformConfig.h \
    tools/ChangeBackground.h \
    tools/Clip.h \
    tools/Composite.h \
    tools/Dense.h \
    tools/DenseSparseTools.h \
    tools/Diagnostics.h \
    tools/Filter.h \
    tools/GridOperators.h \
    tools/GridTransformer.h \
    tools/Interpolation.h \
    tools/LevelSetAdvect.h \

=== debian/changelog ===
openvdb (3.1.0-3b2) staging; urgency=high

  * Increase version again to work around queue issues

 -- Philip Muškovac <yofel@kubuntu.org>  Sat, 19 Mar 2016 00:13:13 +0000

openvdb (3.1.0-3b1) staging; urgency=high

  * No-change rebuild against liblog4cplus-1.1.9

 -- Philip Muškovac <yofel@kubuntu.org>  Sat, 19 Mar 2016 00:13:13 +0000

openvdb (3.1.0-3) unstable; urgency=medium

  * FTBFS when built with dpkg-buildpackage -A. Closes: #807023
  * public extension linked with libpython2.7. Closes: #801861
  * add direct build-dependency on libglu. Closes: #813016

 -- Mathieu Malaterre <malat@debian.org>  Tue, 01 Mar 2016 10:27:33 +0100

openvdb (3.1.0-2) unstable; urgency=medium

  * Fix compilation on 32bits. Closes: #801802

 -- Mathieu Malaterre <malat@debian.org>  Fri, 16 Oct 2015 13:55:15 +0200

openvdb (3.1.0-1) unstable; urgency=medium

  * new upstream
  * add c-blosc
  * Remove symbols file, too complex to maintain
  * register doc against doc-base
  * Remove numpy warnings. Closes: #751761

 -- Mathieu Malaterre <malat@debian.org>  Tue, 13 Oct 2015 17:03:48 +0200

openvdb (3.0.0-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Build-depend on libtbb-dev (>= 4.3~20150611-0.1).
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Sun, 06 Sep 2015 14:16:56 +0200

openvdb (3.0.0-3.1) unstable; urgency=high

  * Non-maintainer upload.
  * Include -latomic in the linker line to deal with the new libtbb.
    Closes: #787084.
  * Regenerate the symbols file for the new libstdc++ ABI.
    Closes: #791740.

 -- Matthias Klose <doko@debian.org>  Thu, 03 Sep 2015 23:45:14 +0200

=== debian/control ===
Source: openvdb
Section: libs
Priority: optional
Maintainer: Mathieu Malaterre <malat@debian.org>
Build-Depends: debhelper (>= 9),
               dh-python,
               dpkg-dev (>= 1.18.0),
               libblosc-dev,
               libboost-dev (>= 1.46),
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-python-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libcppunit-dev,
               libglfw3-dev,
               libglu1-mesa-dev | libglu1-dev,
               libjemalloc-dev,
               liblog4cplus-dev,
               libopenexr-dev,
               libtbb-dev (>= 4.3~20150611-0.1),
               libz-dev,
               python-all-dev,
               python-numpy
Build-Depends-Indep: doxygen-latex, graphviz, python-epydoc
Homepage: http://openvdb.org
Vcs-Browser: http://anonscm.debian.org/viewvc/collab-maint/deb-maint/openvdb/trunk/
Vcs-Svn: svn://anonscm.debian.org/collab-maint/deb-maint/openvdb/trunk
Standards-Version: 3.9.6
X-Python-Version: 2.7

Package: libopenvdb3.1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Sparse Volume Processing toolkit - lib
 OpenVDB is an open source C++ library comprising a novel hierarchical data
 structure and a suite of tools for the efficient storage and manipulation of
 sparse volumetric data discretized on three-dimensional grids. It is developed
 and maintained by DreamWorks Animation for use in volumetric applications
 typically encountered in feature film production.
 .
 This package contains the libraries needed to run OpenVDB applications

Package: libopenvdb-dev
Architecture: any
Section: libdevel
Depends: libopenvdb3.1 (= ${binary:Version}), ${misc:Depends}
Description: Sparse Volume Processing toolkit - dev
 OpenVDB is an open source C++ library comprising a novel hierarchical data
 structure and a suite of tools for the efficient storage and manipulation of
 sparse volumetric data discretized on three-dimensional grids. It is developed
 and maintained by DreamWorks Animation for use in volumetric applications
 typically encountered in feature film production.
 .
 This is the package for developping OpenVDB applications

Package: libopenvdb-doc
Architecture: all
Section: doc
Depends: doc-base, ${misc:Depends}
Description: Sparse Volume Processing toolkit - doc
 OpenVDB is an open source C++ library comprising a novel hierarchical data
 structure and a suite of tools for the efficient storage and manipulation of
 sparse volumetric data discretized on three-dimensional grids. It is developed
 and maintained by DreamWorks Animation for use in volumetric applications
 typically encountered in feature film production.
 .
 This is the package for the doc files for OpenVDB

Package: libopenvdb-tools
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Sparse Volume Processing toolkit - runtime
 OpenVDB is an open source C++ library comprising a novel hierarchical data
 structure and a suite of tools for the efficient storage and manipulation of
 sparse volumetric data discretized on three-dimensional grids. It is developed
 and maintained by DreamWorks Animation for use in volumetric applications
 typically encountered in feature film production.
 .
 This is the package for the runtime. It installs vdb_print, vdb_render and
 vdb_view

Package: python-openvdb
Architecture: any
Section: python
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Provides: ${python:Provides}
Description: Sparse Volume Processing toolkit - Python binding
 OpenVDB is an open source C++ library comprising a novel hierarchical data
 structure and a suite of tools for the efficient storage and manipulation of
 sparse volumetric data discretized on three-dimensional grids. It is developed
 and maintained by DreamWorks Animation for use in volumetric applications
 typically encountered in feature film production.
 .
 This is the package for the Python binding.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# as per upstream request:
#export DEB_CFLAGS_MAINT_APPEND = -fvisibility=hidden

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
VER_FULL = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d-)
VER_SONAME = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d- | cut -f1-2 -d.)

#
CFLAGS+=$(CPPFLAGS) -fvisibility=hidden -fvisibility-inlines-hidden
CXXFLAGS+=$(CPPFLAGS) -fvisibility=hidden -fvisibility-inlines-hidden

# tbb issue:
DEB_BUILD_ARCH_CPU := $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU 2>/dev/null)
ifeq ($(DEB_BUILD_ARCH_CPU), arm)
CXXFLAGS+=-Wa,-mimplicit-it=thumb
endif

# deduce documentation option (build-indep target)
ifeq "" "$(filter %-doc,$(shell dh_listpackages))"
  BUILDDOC = DOXYGEN= EPYDOC=
else
  BUILDDOC =
endif

ALLOPTS = $(BUILDDOC) BOOST_PYTHON_LIB=-lboost_python-py27 PYTHON_VERSION=2.7 \
					PYTHON_INCL_DIR=/usr/include/python2.7 NUMPY_INCL_DIR2=/usr/lib/python2.7/dist-packages/numpy/core/include/numpy/ \
					NUMPY_INCL_DIR=/usr/share/pyshared/numpy/core/include/numpy/ HFS=/removeme HT=/usr HDSO=/usr/lib \
					EXR_INCL_DIR=/usr/include/OpenEXR \
					CPPUNIT_INCL_DIR=/usr/include CPPUNIT_LIB_DIR=/usr/lib \
					LOG4CPLUS_INCL_DIR=/usr/include LOG4CPLUS_LIB_DIR=/usr/lib \
					GLFW_INCL_DIR=/usr/include/GL GLFW_LIB_DIR=/usr/lib \
					LIBS_RPATH='$(LDFLAGS) -ldl -lm -lz -lHalf -ltbb -latomic -lblosc -llog4cplus -lboost_filesystem -lboost_system -lboost_iostreams' LIBOPENVDB_RPATH= \
					PYTHON_SONAME_FLAGS= BOOST_PYTHON_LIB=-lboost_python-py27 \
					verbose=yes debug=yes rpath=no shared=yes

%:
	dh $@ --parallel --with python2

MPL: LICENSE
	cp -f $< $@

override_dh_auto_build-arch:
	test -h openvdb || ln -f -s . openvdb
	dh_auto_build -- $(ALLOPTS)

override_dh_auto_test-arch:
	timeout 2h dh_auto_test || true

override_dh_auto_build-indep:
	$(MAKE) doc

# No tests needed for docs
override_dh_auto_test-indep:

override_dh_auto_install-indep:

# do not run make install
override_dh_auto_install-arch:
	dh_auto_install -- $(ALLOPTS) DESTDIR=$(CURDIR)$(DESTDIR)/debian/tmp/usr DESTDIR_LIB_DIR=$(CURDIR)$(DESTDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	rm openvdb

pkg_run = libopenvdb-tools
pkg_lib = libopenvdb$(VER_SONAME)
pkg_dev = libopenvdb-dev
pkg_doc = libopenvdb-doc
pkg_py  = python-openvdb

PYMODDIR := /usr/lib/$(shell pyversions -r)

override_dh_install-indep:

override_dh_install-arch:
	dh_numpy --package=$(pkg_py)
	dh_install -p$(pkg_run) debian/tmp/usr/bin
	dh_install -p$(pkg_lib) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libopenvdb.so.$(VER_SONAME)
	dh_install -p$(pkg_lib) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libopenvdb.so.$(VER_FULL)
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libopenvdb.so
	dh_install -p$(pkg_dev) debian/tmp/usr/include
	#dh_install -p$(pkg_doc) debian/tmp/usr/share/doc
	dh_install -p$(pkg_py)  debian/tmp/usr/python/lib/python2.7/pyopenvdb.so $(PYMODDIR)/dist-packages/

override_dh_installdocs: MPL
	dh_installdocs -A $^

#override_dh_shlibdeps:
#	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_clean:
	#test -h openvdb || { unlink openvdb; }
	dh_clean doc/doxygen_sqlite3.db

# man page cannot be automatically generated since we need to cleanup help2man output
debian/vdb_print.1: debian/vdb_print.1.in
	help2man --version-string=$(VER_FULL) --include=$< --output=$@ --no-info --no-discard-stderr vdb_print

debian/vdb_view.1: debian/vdb_view.1.in
	help2man --version-string=$(VER_FULL) --include=$< --output=$@ --no-info --no-discard-stderr vdb_view

debian/vdb_render.1: debian/vdb_render.1.in
	help2man --version-string=$(VER_FULL) --include=$< --output=$@ --no-info --no-discard-stderr vdb_render

get-orig-source:
	uscan --verbose --force-download --rename --repack

## openvdb 3.2.0

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2012-2015 DreamWorks Animation LLC
+# Copyright (c) 2012-2016 DreamWorks Animation LLC
 #
 # All rights reserved. This software is distributed under the
 # Mozilla Public License 2.0 ( http://www.mozilla.org/MPL/2.0/ )
@@ -91,15 +91,19 @@
 BOOST_THREAD_LIB := -lboost_thread
 
 # The parent directory of the OpenEXR/ header directory
-EXR_INCL_DIR := $(HT)/include
+#EXR_INCL_DIR := $(HT)/include
+EXR_INCL_DIR := /rel/folio/openexr/openexr-1.7.1-latest/sys_include
 # The directory containing IlmImf
-EXR_LIB_DIR := $(HDSO)
+#EXR_LIB_DIR := $(HDSO)
+EXR_LIB_DIR := /rel/folio/openexr/openexr-1.7.1-latest/library
 EXR_LIB := -lIlmImf
 
 # The parent directory of the OpenEXR/ header directory (which contains half.h)
-ILMBASE_INCL_DIR := $(EXR_INCL_DIR)
+#ILMBASE_INCL_DIR := $(EXR_INCL_DIR)
+ILMBASE_INCL_DIR := /rel/folio/ilmbase/ilmbase-1.0.3-latest/sys_include
 # The directory containing libIlmThread, libIlmThread, libHalf etc.
-ILMBASE_LIB_DIR := $(EXR_LIB_DIR)
+#ILMBASE_LIB_DIR := $(EXR_LIB_DIR)
+ILMBASE_LIB_DIR := /rel/folio/ilmbase/ilmbase-1.0.3-latest/library
 ILMBASE_LIB := -lIlmThread -lIex -lImath
 HALF_LIB := -lHalf
 
@@ -166,7 +170,7 @@
 NUMPY_INCL_DIR := /rel/map/generic-2013.22/include
 # The Epydoc executable
 # (leave blank if Epydoc is unavailable)
-EPYDOC := epydoc
+EPYDOC := /rel/map/generic_default-2014.24.237/bin/epydoc
 # Set PYTHON_WRAP_ALL_GRID_TYPES to "yes" to specify that the Python module
 # should expose (almost) all of the grid types defined in openvdb.h
 # Otherwise, only FloatGrid, BoolGrid and Vec3SGrid will be exposed
@@ -249,6 +253,8 @@
 ifeq (yes,$(has_log4cplus))
     INCLDIRS += -isystem $(LOG4CPLUS_INCL_DIR)
 endif
+
+CXXFLAGS += -std=c++0x
 
 CXXFLAGS += -pthread $(OPTIMIZE) $(INCLDIRS)
 ifeq (yes,$(has_blosc))
@@ -333,16 +339,3 @@
     metadata/MetaMap.h \
     metadata/StringMetadata.h \
     openvdb.h \
-    Platform.h \
-    PlatformConfig.h \
-    tools/ChangeBackground.h \
-    tools/Clip.h \
-    tools/Composite.h \
-    tools/Dense.h \
-    tools/DenseSparseTools.h \
-    tools/Diagnostics.h \
-    tools/Filter.h \
-    tools/GridOperators.h \
-    tools/GridTransformer.h \
-    tools/Interpolation.h \
-    tools/LevelSetAdvect.h \

=== debian/changelog ===
openvdb (3.2.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build on mips*. Closes: #847752

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 24 Dec 2016 09:31:28 +0100

openvdb (3.2.0-2) unstable; urgency=medium

  * Reactivate old patch (refreshed). Closes: #835419
    + d/p/size_t.patch
  * Remove old patch, not needed anymore:
    - d/p/fixnumpy.patch

 -- Mathieu Malaterre <malat@debian.org>  Fri, 26 Aug 2016 12:13:08 +0200

openvdb (3.2.0-1) unstable; urgency=medium

  * new upstream
  * make sure to remove c++11 compilation mode for now
    + d/p/remove_cxx0.patch

 -- Mathieu Malaterre <malat@debian.org>  Tue, 23 Aug 2016 14:44:24 +0200

openvdb (3.1.0-4) unstable; urgency=medium

  * Fix compilation with GCC6. Closes: #831067
  * Bump Std-Vers to 3.9.8, no changes needed

 -- Mathieu Malaterre <malat@debian.org>  Thu, 21 Jul 2016 11:37:42 +0200

=== debian/control ===
--- 
+++ 
@@ -26,10 +26,10 @@
 Homepage: http://openvdb.org
 Vcs-Browser: http://anonscm.debian.org/viewvc/collab-maint/deb-maint/openvdb/trunk/
 Vcs-Svn: svn://anonscm.debian.org/collab-maint/deb-maint/openvdb/trunk
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 X-Python-Version: 2.7
 
-Package: libopenvdb3.1
+Package: libopenvdb3.2
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
@@ -45,7 +45,7 @@
 Package: libopenvdb-dev
 Architecture: any
 Section: libdevel
-Depends: libopenvdb3.1 (= ${binary:Version}), ${misc:Depends}
+Depends: libopenvdb3.2 (= ${binary:Version}), ${misc:Depends}
 Description: Sparse Volume Processing toolkit - dev
  OpenVDB is an open source C++ library comprising a novel hierarchical data
  structure and a suite of tools for the efficient storage and manipulation of

=== debian/rules ===
--- 
+++ 
@@ -20,6 +20,12 @@
 CXXFLAGS+=-Wa,-mimplicit-it=thumb
 endif
 
+# Disable optimization on mips* because the compiler is running out of memory
+# see #847752
+ifneq (,$(filter $(DEB_BUILD_ARCH_CPU), mips mipsel))
+CXXFLAGS:=$(filter-out -O2,$(CXXFLAGS)) -O1
+endif
+
 # deduce documentation option (build-indep target)
 ifeq "" "$(filter %-doc,$(shell dh_listpackages))"
   BUILDDOC = DOXYGEN= EPYDOC=
@@ -27,15 +33,17 @@
   BUILDDOC =
 endif
 
-ALLOPTS = $(BUILDDOC) BOOST_PYTHON_LIB=-lboost_python-py27 PYTHON_VERSION=2.7 \
-					PYTHON_INCL_DIR=/usr/include/python2.7 NUMPY_INCL_DIR2=/usr/lib/python2.7/dist-packages/numpy/core/include/numpy/ \
-					NUMPY_INCL_DIR=/usr/share/pyshared/numpy/core/include/numpy/ HFS=/removeme HT=/usr HDSO=/usr/lib \
-					EXR_INCL_DIR=/usr/include/OpenEXR \
-					CPPUNIT_INCL_DIR=/usr/include CPPUNIT_LIB_DIR=/usr/lib \
-					LOG4CPLUS_INCL_DIR=/usr/include LOG4CPLUS_LIB_DIR=/usr/lib \
-					GLFW_INCL_DIR=/usr/include/GL GLFW_LIB_DIR=/usr/lib \
+TESTOPS = CPPUNIT_INCL_DIR=/usr/include CPPUNIT_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
+					EXR_INCL_DIR=/usr/include/OpenEXR EXR_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
+					ILMBASE_INCL_DIR=/usr/include/OpenEXR ILMBASE_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
+					HT=/usr HDSO=/usr/lib \
+					LOG4CPLUS_INCL_DIR=/usr/include LOG4CPLUS_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
+ALLOPTS = $(BUILDDOC) $(TESTOPS) BOOST_PYTHON_LIB=-lboost_python-py27 PYTHON_VERSION=2.7 \
+					BOOST_PYTHON_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) PYTHON_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
+					PYTHON_INCL_DIR=/usr/include/python2.7 NUMPY_INCL_DIR=/usr/lib/python2.7/dist-packages/numpy/core/include/numpy/ \
+					PYTHON_SONAME_FLAGS= \
+					GLFW_INCL_DIR=/usr/include/GL GLFW_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
 					LIBS_RPATH='$(LDFLAGS) -ldl -lm -lz -lHalf -ltbb -latomic -lblosc -llog4cplus -lboost_filesystem -lboost_system -lboost_iostreams' LIBOPENVDB_RPATH= \
-					PYTHON_SONAME_FLAGS= BOOST_PYTHON_LIB=-lboost_python-py27 \
 					verbose=yes debug=yes rpath=no shared=yes
 
 %:
@@ -49,7 +57,7 @@
 	dh_auto_build -- $(ALLOPTS)
 
 override_dh_auto_test-arch:
-	timeout 2h dh_auto_test || true
+	timeout 2h dh_auto_test -- $(TESTOPS) || true
 
 override_dh_auto_build-indep:
 	$(MAKE) doc

## openvdb 5.0.0

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2012-2016 DreamWorks Animation LLC
+# Copyright (c) 2012-2017 DreamWorks Animation LLC
 #
 # All rights reserved. This software is distributed under the
 # Mozilla Public License 2.0 ( http://www.mozilla.org/MPL/2.0/ )
@@ -38,6 +38,7 @@
 #   pytest              unit tests for the Python module
 #   pydoc               HTML documentation for the Python module
 #                       (doc/html/python/index.html)
+#   vdb_lod             command-line tool to generate volume mipmaps
 #   vdb_print           command-line tool to inspect OpenVDB files
 #   vdb_render          command-line tool to ray-trace OpenVDB files
 #   vdb_view            command-line tool to view OpenVDB files
@@ -46,13 +47,16 @@
 #   all                 [default target] all of the above
 #   install             install all of the above except vdb_test
 #                       into subdirectories of DESTDIR
+#   install_lib         install just the OpenVDB library and its headers
+#                       into subdirectories of DESTDIR
 #   depend              recompute source file header dependencies
 #   clean               delete generated files from the local directory
 #   test                run tests
 #
 # Options:
-#   abi=2               build for compatibility with the OpenVDB 2.x Grid ABI
-#                       (some OpenVDB 3.x features will be disabled)
+#   abi=N               build for compatibility with version N of the
+#                       OpenVDB Grid ABI, where N is 2, 3, 4, etc.
+#                       (some newer features will be disabled)
 #   shared=no           link executables against static OpenVDB libraries
 #                       (default: link against shared libraries)
 #   debug=yes           build with debugging symbols and without optimization
@@ -73,15 +77,18 @@
 #
 # To build the OpenVDB Python module, you will need local distributions of
 # Python, Boost.Python, and optionally NumPy.  As of Houdini 12.5, the HDK
-# includes versions 2.5 and 2.6 of Python as well as the Boost.Python headers.
-# Unfortunately, it does not include the libboost_python library, nor does it
-# include NumPy, so both Boost.Python and NumPy have to be built separately.
+# includes Python 2.x as well as the Boost.Python headers.  Unfortunately,
+# it does not include the libboost_python library, nor does it include NumPy,
+# so both Boost.Python and NumPy have to be built separately.
 # Point the variables $(BOOST_PYTHON_LIB_DIR), $(BOOST_PYTHON_LIB) and
 # $(NUMPY_INCL_DIR) below to your local distributions of those libraries.
 #
 
 # The directory into which to install libraries, executables and header files
 DESTDIR := /tmp/OpenVDB
+
+# The directory into which to install libraries (e.g., for Linux multiarch support)
+DESTDIR_LIB_DIR := $(DESTDIR)/lib
 
 # The parent directory of the boost/ header directory
 BOOST_INCL_DIR := $(HT)/include
@@ -91,19 +98,15 @@
 BOOST_THREAD_LIB := -lboost_thread
 
 # The parent directory of the OpenEXR/ header directory
-#EXR_INCL_DIR := $(HT)/include
-EXR_INCL_DIR := /rel/folio/openexr/openexr-1.7.1-latest/sys_include
+EXR_INCL_DIR := $(HT)/include
 # The directory containing IlmImf
-#EXR_LIB_DIR := $(HDSO)
-EXR_LIB_DIR := /rel/folio/openexr/openexr-1.7.1-latest/library
+EXR_LIB_DIR := $(HDSO)
 EXR_LIB := -lIlmImf
 
 # The parent directory of the OpenEXR/ header directory (which contains half.h)
-#ILMBASE_INCL_DIR := $(EXR_INCL_DIR)
-ILMBASE_INCL_DIR := /rel/folio/ilmbase/ilmbase-1.0.3-latest/sys_include
+ILMBASE_INCL_DIR := $(EXR_INCL_DIR)
 # The directory containing libIlmThread, libIlmThread, libHalf etc.
-#ILMBASE_LIB_DIR := $(EXR_LIB_DIR)
-ILMBASE_LIB_DIR := /rel/folio/ilmbase/ilmbase-1.0.3-latest/library
+ILMBASE_LIB_DIR := $(EXR_LIB_DIR)
 ILMBASE_LIB := -lIlmThread -lIex -lImath
 HALF_LIB := -lHalf
 
@@ -137,9 +140,9 @@
 
 # The parent directory of the log4cplus/ header directory
 # (leave blank if log4cplus is unavailable)
-LOG4CPLUS_INCL_DIR := /rel/folio/log4cplus/log4cplus-1.0.3-latest/sys_include
+LOG4CPLUS_INCL_DIR := /rel/folio/log4cplus/log4cplus-1.1.2-latest/sys_include
 # The directory containing liblog4cplus
-LOG4CPLUS_LIB_DIR := /rel/folio/log4cplus/log4cplus-1.0.3-latest/library
+LOG4CPLUS_LIB_DIR := /rel/folio/log4cplus/log4cplus-1.1.2-latest/library/c++11
 LOG4CPLUS_LIB := -llog4cplus
 
 # The directory containing glfw.h
@@ -154,7 +157,7 @@
 
 # The version of Python for which to build the OpenVDB module
 # (leave blank if Python is unavailable)
-PYTHON_VERSION := 2.6
+PYTHON_VERSION := 2.7
 # The directory containing Python.h
 PYTHON_INCL_DIR := $(HFS)/python/include/python$(PYTHON_VERSION)
 # The directory containing pyconfig.h
@@ -163,11 +166,11 @@
 PYTHON_LIB_DIR := $(HFS)/python/lib
 PYTHON_LIB := -lpython$(PYTHON_VERSION)
 # The directory containing libboost_python
-BOOST_PYTHON_LIB_DIR := /rel/depot/third_party_build/boost/rhel6-1.46.1-0/lib
-BOOST_PYTHON_LIB := -lboost_python-gcc41-mt-python26-1_46_1
+BOOST_PYTHON_LIB_DIR := /rel/config/studio/baseline/boost/1.55.0.0/gcc-4.8.1.0/python-2.7.10.0/ext/lib/
+BOOST_PYTHON_LIB := -lboost_python-mt
 # The directory containing arrayobject.h
 # (leave blank if NumPy is unavailable)
-NUMPY_INCL_DIR := /rel/map/generic-2013.22/include
+NUMPY_INCL_DIR := /rel/lang/python/2.7.9-1/lib/python2.7/site-packages/numpy/core/include/numpy/
 # The Epydoc executable
 # (leave blank if Epydoc is unavailable)
 EPYDOC := /rel/map/generic_default-2014.24.237/bin/epydoc
@@ -254,7 +257,7 @@
     INCLDIRS += -isystem $(LOG4CPLUS_INCL_DIR)
 endif
 
-CXXFLAGS += -std=c++0x
+CXXFLAGS += -std=c++11
 
 CXXFLAGS += -pthread $(OPTIMIZE) $(INCLDIRS)
 ifeq (yes,$(has_blosc))
@@ -263,8 +266,10 @@
 ifeq (yes,$(has_log4cplus))
     CXXFLAGS += -DOPENVDB_USE_LOG4CPLUS
 endif
-ifeq (2,$(strip $(abi)))
-    CXXFLAGS += -DOPENVDB_2_ABI_COMPATIBLE
+abi := $(strip $(abi))
+ifneq (,$(abi))
+    CXXFLAGS += -DOPENVDB_3_ABI_COMPATIBLE  # TODO: deprecated
+    CXXFLAGS += -DOPENVDB_ABI_VERSION_NUMBER=$(abi)
 endif
 ifneq (2,$(strip $(GLFW_MAJOR_VERSION)))
     CXXFLAGS += -DOPENVDB_USE_GLFW_3
@@ -329,13 +334,3 @@
     math/Ray.h \
     math/Stats.h \
     math/Stencils.h \
-    math/Transform.h\
-    math/Tuple.h\
-    math/Vec2.h \
-    math/Vec3.h \
-    math/Vec4.h \
-    Metadata.h \
-    metadata/Metadata.h \
-    metadata/MetaMap.h \
-    metadata/StringMetadata.h \
-    openvdb.h \

=== debian/changelog ===
openvdb (5.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Remove patch not needed: d/p/fixversionnamesrc.patch
  * Remove patch applied upstream: d/p/install_lib.patch
  * Add patch that remove explicit -std=c++11

 -- Mathieu Malaterre <malat@debian.org>  Tue, 26 Dec 2017 10:41:24 +0100

openvdb (4.0.2-3) unstable; urgency=medium

  * Add dep on libilmbase-dev. Closes: #879896
  * Fix build on sh4
  * Bump Std-Vers to 4.1.2, no changes needed
  * Install missing vdb_lod man page

 -- Mathieu Malaterre <malat@debian.org>  Wed, 13 Dec 2017 12:55:40 +0100

openvdb (4.0.2-2) unstable; urgency=high

  * Fix build on mips*. Closes: #879636

 -- Mathieu Malaterre <malat@debian.org>  Wed, 22 Nov 2017 21:46:44 +0100

openvdb (4.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Std-Vers to 4.1.0, no changes needed

 -- Mathieu Malaterre <malat@debian.org>  Thu, 21 Sep 2017 22:15:57 +0200

=== debian/control ===
--- 
+++ 
@@ -26,10 +26,10 @@
 Homepage: http://openvdb.org
 Vcs-Browser: http://anonscm.debian.org/viewvc/collab-maint/deb-maint/openvdb/trunk/
 Vcs-Svn: svn://anonscm.debian.org/collab-maint/deb-maint/openvdb/trunk
-Standards-Version: 3.9.8
+Standards-Version: 4.1.2
 X-Python-Version: 2.7
 
-Package: libopenvdb3.2
+Package: libopenvdb5.0
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
@@ -45,7 +45,7 @@
 Package: libopenvdb-dev
 Architecture: any
 Section: libdevel
-Depends: libopenvdb3.2 (= ${binary:Version}), ${misc:Depends}
+Depends: libilmbase-dev, libopenvdb5.0 (= ${binary:Version}), ${misc:Depends}
 Description: Sparse Volume Processing toolkit - dev
  OpenVDB is an open source C++ library comprising a novel hierarchical data
  structure and a suite of tools for the efficient storage and manipulation of

=== debian/rules ===
--- 
+++ 
@@ -21,9 +21,9 @@
 endif
 
 # Disable optimization on mips* because the compiler is running out of memory
-# see #847752
-ifneq (,$(filter $(DEB_BUILD_ARCH_CPU), mips mipsel))
-CXXFLAGS:=$(filter-out -O2,$(CXXFLAGS)) -O1
+# see #847752 / #879636
+ifneq (,$(filter $(DEB_BUILD_ARCH_CPU), mips mipsel sh4))
+CXXFLAGS:=$(filter-out -O2,$(CXXFLAGS)) --param ggc-min-expand=10 -O1
 endif
 
 # deduce documentation option (build-indep target)
@@ -112,5 +112,8 @@
 debian/vdb_render.1: debian/vdb_render.1.in
 	help2man --version-string=$(VER_FULL) --include=$< --output=$@ --no-info --no-discard-stderr vdb_render
 
+debian/vdb_lod.1: debian/vdb_lod.1.in
+	help2man --version-string=$(VER_FULL) --include=$< --output=$@ --no-info --no-discard-stderr vdb_lod
+
 get-orig-source:
 	uscan --verbose --force-download --rename --repack
